import java.io.*;
import java.util.*;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

public class showRootChildrenCount extends DefaultHandler
{
  public static void main(String argv[])
  {
    if (argv.length != 1) {
      System.err.println("Usage: java showRootChildrenCount xmlfilename");
      System.exit(1);
    }

     // Use an instance of ourselves as the SAX event handler
    DefaultHandler handler = new showRootChildrenCount();
    // Use the default (non-validating) parser
    SAXParserFactory factory = SAXParserFactory.newInstance();

     try {
      SAXParser saxParser = factory.newSAXParser();
      saxParser.parse(new File(argv [0]), handler);

      // print results;
      System.out.println("Number of child elements of the root = " 
		   + countElements);
 

     } catch (Throwable t) {
      t.printStackTrace();
    }
  }

  //  data member
  static private int countElements = 0;
  static private int currentLevel = -1;

  // Handler methods
  public void startElement(String namespaceURI,
      String lName, // local name
      String qName, // qualified name
      Attributes attrs)
    throws SAXException
  {  currentLevel++;
	 if (currentLevel == 1) countElements++;

  } // startElement

    public void endElement(String namespaceURI,
      String lName, // local name
      String qName)
    throws SAXException
  {  currentLevel--;

  } // endElement

} // showRootChildrenCount.